﻿namespace HeuristicLab.BenchmarkSuite.ERC {
  using HeuristicLab.Common;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class ErcOptionRange<T> : ErcOption<T>
    where T : class, IDeepCloneable {
    public ErcOptionRange(T start, T end, params T[] constants) : base(constants) {
      Start = start;
      End = end;
    }

    [StorableConstructor]
    public ErcOptionRange(bool deserializing) : base(deserializing) { }

    public ErcOptionRange(ErcOptionRange<T> origin, Cloner cloner) : base(origin, cloner) {
      Start = cloner.Clone(origin.Start);
      End = cloner.Clone(origin.End);
    }

    public T Start { get; set; }
    public T End { get; set; }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new ErcOptionRange<T>(this, cloner);
    }
  }
}
