﻿using System;

namespace HeuristicLab.Problems.ProgramSynthesis.Push.Attributes {
  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;

  [AttributeUsage(AttributeTargets.Class)]
  public class PushExpressionAttribute : Attribute {
    public readonly StackTypes StackTypes;
    public readonly StackTypes AdditionalStackDependencies;
    public readonly string ExpressionName;

    public PushExpressionAttribute(StackTypes stackTypes, string expressionName, StackTypes additionalStackDependencies = default(StackTypes)) {
      this.StackTypes = stackTypes;
      this.AdditionalStackDependencies = additionalStackDependencies;
      this.ExpressionName = expressionName;
    }
  }
}
